package com.acj0.orangediaryproa.mod.backup;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.text.format.DateFormat;
import android.text.format.DateUtils;
import android.util.Log;

import com.acj0.orangediaryproa.data.MyApp;
import com.acj0.share.ShareApp;
import com.acj0.share.ShareIntent;
import com.acj0.share.SharePref;
import com.acj0.share.utils.LogUtils;
import com.acj0.share.utils.Util;

public class BackupReceiver extends BroadcastReceiver {
    
	// This module is completely transferrable 2013-12-06
	private static final String TAG = "BackupReceiver";
	
    @Override
    public void onReceive(Context context, Intent intent) {
    	
    	if (intent.getAction().equals(Intent.ACTION_BOOT_COMPLETED)) {
			
			SharedPreferences sp = PreferenceManager.getDefaultSharedPreferences(context);
			boolean backupEnabled = sp.getBoolean(SharePref.KEY_BACKUP_ENABLED, false);
			String timeInterval = sp.getString(SharePref.KEY_BACKUP_INTERVAL, SharePref.VAL_BACKUP_INTERVAL);
			int timeIntervalI = Util.parseInt(timeInterval);

			LogUtils log = new LogUtils(MyApp.BASE_DIR);
			log.logStatus(LogUtils.LOG_BACKUP, "RCV: Reboot: Bk Scdl: "+backupEnabled+"\n");
			
			AlarmManager am = (AlarmManager) context.getSystemService(Context.ALARM_SERVICE);
			
			int requestCode = 0;
			Intent i = new Intent(context, BackupService.class);
			i.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_NO_USER_ACTION);
			i.putExtra(ShareIntent.EXTRA_BACKUP_TYPE, Backup10.BACKUP_TYPE_SCHEDL);
			int flags = PendingIntent.FLAG_CANCEL_CURRENT;
			PendingIntent operation = PendingIntent.getService(context, requestCode, i, flags);
			
			if (backupEnabled) {
				int type = AlarmManager.RTC_WAKEUP;
				long triggerAtMillis = System.currentTimeMillis()+DateUtils.SECOND_IN_MILLIS*30L;
				long intervalMillis = Backup10.TIME_INTERVAL[timeIntervalI];
				
				am.setRepeating(type, triggerAtMillis, intervalMillis, operation);
	            if (ShareApp.DEBUG)	Log.e(TAG,"alarm trigger at "+DateFormat.format("k:m s S a", triggerAtMillis));
			}
			else {
				am.cancel(operation);
	            if (ShareApp.DEBUG)	Log.e(TAG,"alarm cancelled ");
			}
		}
    }
    
}