package com.acj0.orangediaryproa;

import android.app.Activity;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.database.Cursor;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.preference.PreferenceManager;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

import com.acj0.orangediaryproa.data.DBAdapter;
import com.acj0.orangediaryproa.data.EntryData;
import com.acj0.orangediaryproa.data.EntryOper;
import com.acj0.orangediaryproa.data.Intent1;
import com.acj0.orangediaryproa.data.Multimedia;
import com.acj0.orangediaryproa.data.MyApp;
import com.acj0.share.utils.IOUtils;

public class PrefAutoExport extends Activity {

	// auto export
	private static final String TAG="PrefAutoExport";
	
	// Menu
//	private static final int MENU_ITEM_SEND = 1;
	
	// MV
	private DBAdapter mDbHelper;
	private EntryOper mNote1;
	private Multimedia mMM;
	private String mMsgbody;
	
	private int successCountXML;
	private int failCountXML;
//	private int successCountImg;
//	private int failCountImg;
	
	// Layout
	private ToggleButton tb_01;
	private Button bt_browse;
	
	// dialog
//	private static final int DIA_TARGET_CAL = 	0;

	
	// Preferences
	private SharedPreferences mSharedPref;
	private SharedPreferences.Editor mSharedPrefEdit;
	private boolean mPrefAutoExport;
	
	// handler
	private static final int HANDLER_EXPORT = 0;
	
	private ProgressDialog mProgressDialog;
	
	private final Handler handler = new Handler() {
		@Override
		public void handleMessage(final Message msg) {
			mProgressDialog.dismiss();
			
			String text=null;
			
			switch (msg.what) {
			case HANDLER_EXPORT:		
				text = "Run completed!\n"+successCountXML+" entry texts exported";
				Toast.makeText(PrefAutoExport.this, text, Toast.LENGTH_LONG).show();
				break;
			}
		}
	};
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		// Extras
        Bundle extras = getIntent().getExtras();
		if (extras != null) {
//			mSelectedFile = extras.getString("mSelectedFile");
		}

		// MV
		mSharedPref = PreferenceManager.getDefaultSharedPreferences(this);
		mSharedPrefEdit = mSharedPref.edit();
		mDbHelper = new DBAdapter(this);
		mNote1 = new EntryOper(this,mDbHelper);
		mMM = new Multimedia(this);
		
		initContentView();
		
		tb_01.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				mPrefAutoExport = isChecked;
				mSharedPrefEdit.putBoolean(MyPref.KEY_EXPORT_AUTO, mPrefAutoExport);
				mSharedPrefEdit.commit();
			}
		});
		
		tb_01.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				if (tb_01.isChecked()) {
					initAutoExport();
				}
			}
		});
		
		bt_browse.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				Intent i = new Intent(PrefAutoExport.this, PrefImportFile.class);
		    	i.putExtra(Intent1.EXTRA_LIST_TYPE, PrefImportFile.SCR_MODE_XML);
				startActivity(i);
			}
		});
		
		mDbHelper.open();
        
	}
	
	@Override
	protected void onResume() {
        loadPreferences();
        
        tb_01.setChecked(mPrefAutoExport);
		
		super.onResume();
	}

	@Override
	protected void onPause() {
		super.onPause();
	}
	
	@Override
	protected void onDestroy() {
		mDbHelper.close();
		super.onDestroy();
	}

	@Override 
    public void onSaveInstanceState(Bundle outState) {
    	super.onSaveInstanceState(outState); 
    }

    
    @Override
    public void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
    }
    
    @Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
	}
	
    @Override
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
//		menu.add(0, MENU_ITEM_SEND, 0, "Send to developer")
//		.setIcon(R.drawable.ic_menu_upload);
		return true;
	}

	@Override
	public boolean onPrepareOptionsMenu(Menu menu) {
		super.onPrepareOptionsMenu(menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
//	    switch (item.getItemId()) {
//	    case MENU_ITEM_SEND:
//			break;
//        }
		return true;
	}
	
	public void loadPreferences() {
		mPrefAutoExport = mSharedPref.getBoolean(MyPref.KEY_EXPORT_AUTO, MyPref.VAL_EXPORT_AUTO);
	}	


	@Override
	protected Dialog onCreateDialog(int id) {
		switch (id) {
//		case DIA_TARGET_CAL:		return buildDialog0();		
		}
		return null;
	}

	@Override
	protected void onPrepareDialog(int id, Dialog dialog) {
	}
	
	// refresh ========================================
	public void initContentView() {
		
		// Layout
		setContentView(R.layout.pref_autoexport);
		
		ImageView iv_01 = (ImageView) findViewById(R.id.inc001_iv_01);
		TextView tv_01 = (TextView) findViewById(R.id.inc001_tv_01);
		
		tb_01 = (ToggleButton) findViewById(R.id.tb_01);

		TextView tv_instr = (TextView) findViewById(R.id.inc202_tv_01);
		bt_browse = (Button) findViewById(R.id.inc202_bt_01);
		
		iv_01.setImageResource(R.drawable.ic_menud_export);
		tv_01.setText(R.string.prefexport2_title);
		tv_instr.setText("");
		
		bt_browse.setText(R.string.prefexport2_browse);
		
	}
	
	
	public void initAutoExport() {
		CharSequence message = getString(R.string.prefexport2_init);
		mProgressDialog = ProgressDialog.show(PrefAutoExport.this, null, message, true, true);
		new Thread() {
			@Override
			public void run() {
				exportAllEntries();
				handler.sendEmptyMessage(HANDLER_EXPORT);
			}
		}.start();
	}
	
	public void exportAllEntries() {		// All Files
		
		// 1. cleanup folder
		// clean up Thumb
		String pattern = "([^\\s]+(\\.(?i)(jpg|png|gif|bmp|xml))$)";
//		String pattern = "([^\\s]+(\\.(?i)(xml))$)";
		IOUtils.emptyDir(MyApp.AUTOEXP_DIR, pattern);
		
		// 2. backup entry text in XML

		failCountXML = 0;
		successCountXML = 0;
//		failCountImg = 0;
//		successCountImg = 0;
		
		EntryData ed = new EntryData();
		
		String[] columns = DBAdapter.PROJ_ENTR;
		String orderBy = null;
		Cursor c = mDbHelper.fetchAllNote2(columns, orderBy);
		int count = c.getCount();
		for (int i=0; i<count; i++) {
			c.moveToPosition(i);
			ed.loadData(c);
			
			long entryid = ed.id;
			String title = ed.title;
			long created = ed.created;
			int groupid = ed.marker;
			String body = ed.note;
			
			String msg = mNote1.createAutoExportXML(entryid, title, created, groupid, body);
			if (msg.substring(0,7).equals("Failed!")) {
				failCountXML++;
			}
			else {
				successCountXML++;
			}
			
//			String[] columns1 = DBAdapter.PROJ_ITEM;
//			String type = Item1.TYPE_PHOTO+","+Item1.TYPE_IMAGE;
//			Cursor c1 = mDbHelper.fetchItemByTypeNoteid(columns1, type, entryid);
//			int count1 = c1.getCount();
//			for (int j=0; j<count1; j++) {
//				c1.moveToPosition(j);
//				String fileFullPath = c1.getString(2);
//				
//				String bckFileFullPath = mMM.createBackupImg(fileFullPath, entryid);
//				if (MyApp.DEBUG) Log.e(TAG, "Backup img created:"+bckFileFullPath);
//				if (bckFileFullPath!=null && bckFileFullPath.length()>0) {
//					successCountImg++;
//				}
//				else {
//					failCountImg++;
//				}
//					
//			}
//			c1.close();
			
		}
		c.close();
		
		
		// backup attachment image
//		String type = Item1.TYPE_PHOTO+","+Item1.TYPE_IMAGE;
//		c = mDbHelper.fetchItemByType(DBAdapter.PROJ_ITEM, type);
//		count = c.getCount();
//		for (int i=0; i<count; i++) {
//			c.moveToPosition(i);
//			String fileFullPath = c.getString(2);
//			long entryid = c.getLong(5);
//			
//			String bckFileFullPath = mMM.createBackupImg(fileFullPath, entryid);
//			if (MyApp.DEBUG) Log.e(TAG, "Backup img created:"+bckFileFullPath);
//			if (bckFileFullPath!=null && bckFileFullPath.length()>0) {
//				successCountImg++;
//			}
//			else {
//				failCountImg++;
//			}
//				
//		}
//		c.close();
		
		
	}
	
	
	
	
	
}
