package com.acj0.orangediaryproa.mod.googleapi;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.app.Dialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.database.Cursor;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.text.Html;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import com.acj0.orangediaryproa.ListEntry;
import com.acj0.orangediaryproa.MyPref;
import com.acj0.orangediaryproa.data.DBAdapter;
import com.acj0.orangediaryproa.data.EntryOper;
import com.acj0.orangediaryproa.data.Export1;
import com.acj0.orangediaryproa.data.Intent1;
import com.acj0.orangediaryproa.data.LabelOper;
import com.acj0.orangediaryproa.data.MyApp;
import com.acj0.share.R;
import com.acj0.share.ShareIntent;
import com.acj0.share.SharePref;

public class UploaderGDocs extends Activity{

	private static final String TAG = "UploaderGDocs";
	
//	private static final int REQUEST_GOOGLE_AM = 0;
	
	// MV
	private int mExtraListType;	
	private String mExtraLabelId;	
	private String mExtraSrchSelStr;		
	private String[] mExtraSrchSelArgs;		
	private String mExtraSrchSelDesc;		
	
	private DBAdapter mDbHelper;
	private EntryOper mEntry1;
	private Cursor mCursor;

//	private MslAccountManager mAM;
	private List<String> mListImage;
	
	// dialog
//	private static final int DIA_ACCOUNTS = 	1;
	
	// Pref
	private SharedPreferences mSharedPref;
	private SharedPreferences.Editor mSharedPrefEdit;

	private String mPrefGoogleUser;
	private String mPrefGooglePass;
	private int mPrefEntrySortOrder;
	private int mPrefGDocsType;

	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		
		// Extras
		Bundle extras = getIntent().getExtras();
		if (extras != null) {
			mExtraListType = extras.getInt(Intent1.EXTRA_LIST_TYPE);
    		mExtraLabelId = extras.getString(Intent1.EXTRA_LABEL_ID);
        	mExtraSrchSelStr = extras.getString(Intent1.EXTRA_SRCH_SEL_STR);
        	mExtraSrchSelArgs = extras.getStringArray(Intent1.EXTRA_SRCH_SEL_ARG);
        	mExtraSrchSelDesc = extras.getString(Intent1.EXTRA_SRCH_SEL_DSC);
		}

		// MV
		mDbHelper = new DBAdapter(this);
//		mAM = new MslAccountManager(this);
		mEntry1 = new EntryOper(this,mDbHelper);
        
		mSharedPref = PreferenceManager.getDefaultSharedPreferences(this);
		mSharedPrefEdit = mSharedPref.edit();

        // Layout
		initContentView();
		
		bt_user.setOnClickListener(new View.OnClickListener() {
			public void onClick(View view) {
				Intent1.startPrefAccount(UploaderGDocs.this);
			}
		});
		
		rg_00.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(RadioGroup group, int checkedId) {
				if (MyApp.DEBUG) Log.e(TAG, "setOnCheckedChangeListener");
				refreshSelectionAttachment();
				
				mPrefGDocsType = (checkedId==R.id.rb_00 ? 0 : 1);
				mSharedPrefEdit.putInt(SharePref.KEY_EXPORT_GDOCS_TYPE, mPrefGDocsType);
				mSharedPrefEdit.commit();
			}
		});
		
		// update
		bt_01.setOnClickListener(new View.OnClickListener() {
			public void onClick(View view) {
				triggerService();
			}
		});
		
		bt_03.setOnClickListener(new View.OnClickListener() {
			public void onClick(View view) {
				finish();
			}
		});

		
	}
	
	
	
	@Override
	protected void onResume() {
		mDbHelper.open();
		
		loadPreference();
		refreshTvAccount();
		
		getCursor();
		getImages();
		refreshSelectionAttachment();
		
		rg_00.check((mPrefGDocsType==0 ? R.id.rb_00 : R.id.rb_01));
		
		super.onResume();
	}
    
    @Override
	protected void onPause() {
    	if (mCursor!=null) mCursor.close();
    	mDbHelper.close();
    	super.onPause();
	}
	
    @Override
	protected void onDestroy() {
    	super.onDestroy();
	}
    
    public void loadPreference() {
    	mPrefGoogleUser = mSharedPref.getString(SharePref.KEY_GOOGLE_USER, "");
		mPrefGooglePass = mSharedPref.getString(SharePref.KEY_GOOGLE_PASS, "");
		mPrefGDocsType = mSharedPref.getInt(SharePref.KEY_EXPORT_GDOCS_TYPE, SharePref.VAL_EXPORT_GDOCS_TYPE);
		mPrefEntrySortOrder = mSharedPref.getInt(MyPref.KEY_LISTENTRY_SORT_ORDER, MyPref.VAL_LISTENTRY_SORT_ORDER);
	}
    
//    @Override
//	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
//		super.onActivityResult(requestCode, resultCode, data);
//		switch (requestCode) {
//		case REQUEST_GOOGLE_AM:
//			if (resultCode == RESULT_OK) {
//				gotAccount();
//			}
//			else {
//				chooseAccount();
//			}
//			break;
//		}
//	}
    
    @Override 
    public void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState); 
    }
    
    @Override
    public void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
    }

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
    	super.onConfigurationChanged(newConfig);
	}

	
	@Override
	protected Dialog onCreateDialog(int id) {
		switch (id) {
//		case DIA_ACCOUNTS: 				return buildDialog3200(); 
		}
		return null;
	}

	@Override
	protected void onPrepareDialog(int id, Dialog dialog) {
		switch (id) {
//		case DIA_CONFIRM:
//			dia_et_userid.setText(mPrefGoogleUser);
//			dia_et_password.setText(mPrefGooglePass);
//			break;
		}
	}
	
//	public AlertDialog buildDialog3200() {
//		
//		Account[] accounts = mAM.getAccounts();
//		int size = accounts.length;
//	    final String[] names = new String[size];
//	    for (int i=0; i<size; i++) {
//	    	names[i] = accounts[i].name;
//	    }
//	      
//		AlertDialog.Builder builder = new AlertDialog.Builder(this);
//		builder.setTitle("Select a Google account");
//		builder.setItems(names, new DialogInterface.OnClickListener() {
//			public void onClick(DialogInterface dialog, int which) {
//				mAM.setAccountName(names[which]);
//				mAM = new MslAccountManager(UploaderGDocs.this);
//				gotAccount();
//			}
//		});
//		return builder.create();
//	}
	
	// Layout
	private Button bt_user;
	private TextView tv_account;
	private TextView tv_selection;
	private RadioGroup rg_00;
	private TextView tv_attachment;
	
	private Button bt_01;
	private Button bt_02;
	private Button bt_03;
	
	public void initContentView() {
		
		setContentView(R.layout.view_gdocs_uploader);

		//  header
		ImageView iv_01 = (ImageView) findViewById(R.id.inc001_iv_01);
		TextView tv_01 = (TextView) findViewById(R.id.inc001_tv_01);
		iv_01.setImageResource(R.drawable.logo_gdrive);
		tv_01.setText("Google drive uploader");

		// content
		bt_user = (Button) findViewById(R.id.bt_user);
		tv_account = (TextView) findViewById(R.id.tv_account);
		tv_selection = (TextView) findViewById(R.id.tv_selection);
		rg_00 = (RadioGroup) findViewById(R.id.rg_00);
		tv_attachment = (TextView) findViewById(R.id.tv_attachment);

		// buttons
		bt_01 = (Button) findViewById(R.id.inc202_bt_01);
		bt_02 = (Button) findViewById(R.id.inc202_bt_02);
		bt_03 = (Button) findViewById(R.id.inc202_bt_03);

		bt_user.setText("???");
		bt_01.setText("Upload");
		bt_02.setVisibility(View.GONE);
		bt_03.setText(R.string.share_cancel);
	}
	
	public void getCursor() {
		
		if (mCursor!=null)	mCursor.close();
		
		String[] columns = DBAdapter.PROJ_ENTR;
		String orderBy = ListEntry.SORT_ORDER_KEY[mPrefEntrySortOrder];
		switch (mExtraListType) {
		case ListEntry.MODE_TAG:
			if (mExtraLabelId.equals(LabelOper.NO_TAGS)) 
				mCursor = mDbHelper.fetchNoteWithoutLabel(columns,orderBy);
			else 
				mCursor = mDbHelper.fetchNoteByTag(columns, mExtraLabelId,orderBy);
			break;
		case ListEntry.MODE_SRCH:
			mCursor = mDbHelper.fetchNoteByQuery(columns, mExtraSrchSelStr, mExtraSrchSelArgs, orderBy);
			break;
		case ListEntry.MODE_ALL:
			mCursor = mDbHelper.fetchAllNote1(columns, orderBy);
			break;
		}
		
			
	}
	
	public void getImages() {
		
		mListImage = new ArrayList<String>();
		
		int count = mCursor.getCount();
		for (int i=0; i<count; i++) {
			mCursor.moveToPosition(i);
			String[] columns = {DBAdapter.FLD_ITEM_FILEURI};
			long noteid = mCursor.getLong(0);
			String type = "0,1";
			String orderBy = null;
			Cursor c = mDbHelper.fetchItemByNoteidType(columns, noteid, type, orderBy);
			int countj = c.getCount();
			for (int j=0; j<countj; j++) {
				c.moveToPosition(j);
				mListImage.add(c.getString(0));
			}
			c.close();
		}
		
	}
	
	public void refreshSelectionAttachment() {
		
		StringBuilder sb = new StringBuilder();
		sb.append("Number of items: "+mCursor.getCount()+"<br>");
		if (mExtraSrchSelDesc!=null)	sb.append(mExtraSrchSelDesc);
		tv_selection.setText(Html.fromHtml(sb.toString()));
		
		sb = new StringBuilder();
		if (rg_00.getCheckedRadioButtonId()==R.id.rb_00) {	// document
			int count = mListImage.size();
			if (count>0) {
				sb.append("Number of images: "+mListImage.size()+"<br>");
				sb.append(" "+MyApp.PHOTO_DIR.replaceAll(MyApp.ROOT_DIR, "")+"/...<br>");
				for (int i=0; i<count; i++) {
					String fileName = mListImage.get(i).replaceAll(MyApp.PHOTO_DIR+"/", "");
					sb.append("  "+fileName+"<br>");
				}
			}
			else {
				sb.append("No image found.<br>");
			}
		}
		else {												// spreadsheet
			sb.append("Only the text portion of item is exported<br>");
		}
		tv_attachment.setText(Html.fromHtml(sb.toString()));
		
	}
	
	public void refreshTvAccount() {
		
		tv_account.setVisibility(View.GONE);
		
		if (mPrefGoogleUser.length()>0 && mPrefGooglePass.length()>0) {
			bt_user.setTextColor(0xff228000);
			bt_user.setText(mPrefGoogleUser);
			tv_account.setText(mPrefGoogleUser);
			bt_01.setEnabled(true);
		}
		else {
			bt_user.setTextColor(0xffff4040);
			bt_user.setText("No account set");
			tv_account.setText("No account set");
			bt_01.setEnabled(false);
		}
		
	}
	
	public void triggerService() {
		
		int format = (rg_00.getCheckedRadioButtonId()==R.id.rb_00) ? Export1.FORMAT_HTM : Export1.FORMAT_CSV; 
		
		Intent i = new Intent(this, UploaderGDocsService.class);
		i.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_NO_USER_ACTION); // important for background run
		i.putExtra(ShareIntent.EXTRA_EXPORT_FORMAT, format);
		i.putExtra(Intent1.EXTRA_LIST_TYPE, mExtraListType);
		i.putExtra(Intent1.EXTRA_LABEL_ID, mExtraLabelId);
		i.putExtra(Intent1.EXTRA_SRCH_SEL_STR, mExtraSrchSelStr);
		i.putExtra(Intent1.EXTRA_SRCH_SEL_ARG, mExtraSrchSelArgs);
		i.putExtra(Intent1.EXTRA_SRCH_SEL_DSC, mExtraSrchSelDesc);			
		startService(i);
		Toast.makeText(this, "Background job started", Toast.LENGTH_SHORT).show();
		
	}
	
	
	
}